Debian Bug report logs - #474065
Lift the 64000-byte restriction on the size of messages sent to subprocesses.

version graph

Package: apt; Maintainer for apt is APT Development Team <deity@lists.debian.org>; Source for apt is src:apt.

Reported by: Daniel Burrows <dburrows@debian.org>

Date: Thu, 3 Apr 2008 03:33:01 UTC

Severity: normal

Tags: patch

Fixed in version apt/0.7.12

Done: Daniel Burrows <dburrows@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#474065; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Daniel Burrows <dburrows@debian.org>:
New Bug report received and forwarded. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Lift the 64000-byte restriction on the size of messages sent to subprocesses.
Date: Wed, 02 Apr 2008 09:06:03 -0700
[Message part 1 (text/plain, inline)]
Package: apt
Version: 0.7.12
Severity: normal
Tags: patch

  This is related to #473874, my patch to lift the 1024-byte limit on
configuration lines.  It turns out that once apt is able to parse those
lines, it's unable to run any download or install commands; it generates
this error message:

E: Method http has died unexpectedly!

  I tracked this down to a problem in communicating with the subprocess.
The subprocess isn't able to parse the configuration block sent by apt,
and so it dies.  The culprit is ReadMessages in contrib/strutl.cc: it
assumes that no single message block is more than 64000 bytes long, and
apparently dumping the apt configuration with some of these translations
included requires more than 64000 bytes.

  A patch to fix this is attached.  I've tried to preserve the existing
behavior, including (as noted in the patch) what looks to me like a bug
in the parsing algorithm.  I have a notion of how to fix it, but that
will take another bus ride's worth of time.

  Daniel
  

-- Package-specific info:

-- (/etc/apt/preferences present, but not submitted) --


-- (/etc/apt/sources.list present, but not submitted) --


-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable')
Architecture: i386 (i686)

Kernel: Linux 2.6.24-1-686 (SMP w/1 CPU core)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8) (ignored: LC_ALL set to en_US.UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages apt depends on:
ii  debian-archive-keyring        2007.07.31 GnuPG archive keys of the Debian a
ii  libc6                         2.7-10     GNU C Library: Shared libraries
ii  libgcc1                       1:4.3.0-2  GCC support library
ii  libstdc++6                    4.3.0-2    The GNU Standard C++ Library v3

apt recommends no packages.

-- no debconf information
[apt-lift-message-block-limit.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#474065; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Daniel Burrows <dburrows@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 474065@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: 474065@bugs.debian.org
Subject: Re: Bug#474065: Acknowledgement (Lift the 64000-byte restriction on the size of messages sent to subprocesses.)
Date: Thu, 03 Apr 2008 06:15:26 -0700
  I mentioned a bug in ReadMessages in the initial submission.  I'm not
sure whether or not this is really-and-truly a bug, though.  It looks to
me like the code that uses ReadMessages expects to just call it over and
over when input is ready, so as long as we don't actually drop part of a
message (what my patch fixes), I would expect that it's OK if
ReadMessages occasionally exits before consuming all the available
input.

  Daniel




Blocking bugs of 473559 added: 473874 and 474065 Request was from Daniel Burrows <dburrows@debian.org> to control@bugs.debian.org. (Fri, 04 Apr 2008 05:03:08 GMT) Full text and rfc822 format available.

Reply sent to Daniel Burrows <dburrows@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Daniel Burrows <dburrows@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #17 received at 474065-close@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: 474065-close@bugs.debian.org
Subject: Bug#474065: fixed in apt 0.7.12
Date: Sun, 27 Apr 2008 20:47:03 +0000
Source: apt
Source-Version: 0.7.12

We believe that the bug you reported is fixed in the latest version of
apt, which is due to be installed in the Debian FTP archive:

apt-doc_0.7.12_all.deb
  to pool/main/a/apt/apt-doc_0.7.12_all.deb
apt-transport-https_0.7.12_i386.deb
  to pool/main/a/apt/apt-transport-https_0.7.12_i386.deb
apt-utils_0.7.12_i386.deb
  to pool/main/a/apt/apt-utils_0.7.12_i386.deb
apt_0.7.12.dsc
  to pool/main/a/apt/apt_0.7.12.dsc
apt_0.7.12.tar.gz
  to pool/main/a/apt/apt_0.7.12.tar.gz
apt_0.7.12_i386.deb
  to pool/main/a/apt/apt_0.7.12_i386.deb
libapt-pkg-dev_0.7.12_i386.deb
  to pool/main/a/apt/libapt-pkg-dev_0.7.12_i386.deb
libapt-pkg-doc_0.7.12_all.deb
  to pool/main/a/apt/libapt-pkg-doc_0.7.12_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 474065@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Burrows <dburrows@debian.org> (supplier of updated apt package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 26 Apr 2008 12:24:35 -0700
Source: apt
Binary: apt apt-doc libapt-pkg-dev libapt-pkg-doc apt-utils apt-transport-https
Architecture: source all i386
Version: 0.7.12
Distribution: unstable
Urgency: low
Maintainer: APT Development Team <deity@lists.debian.org>
Changed-By: Daniel Burrows <dburrows@debian.org>
Description: 
 apt        - Advanced front-end for dpkg
 apt-doc    - Documentation for APT
 apt-transport-https - APT https transport
 apt-utils  - APT utility programs
 libapt-pkg-dev - Development files for APT's libapt-pkg and libapt-inst
 libapt-pkg-doc - Documentation for APT development
Closes: 337758 412900 444922 448492 466842 466845 469581 470115 471341 473710 473874 474065 476839
Changes: 
 apt (0.7.12) unstable; urgency=low
 .
   [ Michael Vogt ]
   * cmdline/apt-key:
     - add support for a master-keyring that contains signing keys
       that can be used to sign the archive signing keys. This should
       make key-rollover easier.
   * apt-pkg/deb/dpkgpm.cc:
     - merged patch from Kees Cook to fix anoying upper-case display
       on amd64 in sbuild
   * apt-pkg/algorithms.cc:
     - add APT::Update::Post-Invoke-Success script slot
     - Make the breaks handling use the kill list. This means, that a
       Breaks: Pkg (<< version) may put Pkg onto the remove list.
   * apt-pkg/deb/debmetaindex.cc:
     - add missing "Release" file uri when apt-get update --print-uris
       is run
   * methods/connect.cc:
     - remember hosts with Resolve failures or connect Timeouts
   * cmdline/apt-get.cc:
     - fix incorrect help output for -f (LP: #57487)
     - do two passes when installing tasks, first ignoring dependencies,
       then resolving them and run the problemResolver at the end
       so that it can correct any missing dependencies
   * debian/apt.cron.daily:
     - sleep random amount of time (default within 0-30min) before
       starting the upate to hit the mirrors less hard
   * doc/apt_preferences.5.xml:
     - fix typo
 .
   [ Christian Perrier ]
   * Fix typos in manpages. Thanks to Daniel Leidert for the fixes
     Closes: #444922
   * Fix syntax/copitalisation in some messages. Thanks to Jens Seidel
     for pointing this and providing the patch.
     Closes: #466845
   * Fix Polish offline translation. Thanks to Robert Luberda for the patch
     and apologies for applying it very lately. Closes: #337758
   * Fix typo in offline.sgml. Closes: #412900
 .
   [ Program translations ]
     - German updated. Closes: #466842
     - Swedish updated.
     - Polish updated. Closes: #469581
     - Slovak updated. Closes: #471341
     - French updated.
     - Bulgarian updated. Closes: #448492
     - Galician updated. Closes: #476839
 .
   [ Daniel Burrows ]
   * apt-pkg/depcache.cc:
     - Patch MarkInstall to follow currently satisfied Recommends even
       if they aren't "new", so that we automatically force upgrades
       when the version of a Recommends has been tightened.  (Closes: #470115)
     - Enable more complete debugging information when Debug::pkgAutoRemove
       is set.
   * apt-pkg/contrib/configuration.cc
     - Lift the 1024-byte limit on lines in configuration files.
       (Closes: #473710, #473874)
   * apt-pkg/contrib/strutl.cc:
     - Lift the 64000-byte limit on individual messages parsed by ReadMessages.
       (Closes: #474065)
   * debian/rules:
     - Add missing Build-Depends-Indep on xsltproc, docbook-xsl, and xmlto.
Checksums-Sha1: 
 883235dc226cf77f7d41a86a79c685c810dbbed9 1167 apt_0.7.12.dsc
 d322cff948673dccc940e545cce61483db5060c5 1818439 apt_0.7.12.tar.gz
 a41b93c6202f3f7ceab7c64424bbf940777ead0f 95246 apt-doc_0.7.12_all.deb
 594f8e45d51605745e4e2d551c7e8a18e661f9b5 119730 libapt-pkg-doc_0.7.12_all.deb
 917974a3a408d12e5efb36236964caa47985ed6e 1615134 apt_0.7.12_i386.deb
 687407ad2e442fffe248b399a510cc91819f0e8c 104200 libapt-pkg-dev_0.7.12_i386.deb
 533b707b600ae124e475297356836a0fae2af808 192318 apt-utils_0.7.12_i386.deb
 5cb1cdac94193f60e5e46a21255faad9c5c278f3 54250 apt-transport-https_0.7.12_i386.deb
Checksums-Sha256: 
 2f23b8c290e648d06fe58d50b55e76a0ada3995bdda7aa0cb1d025ae885b7b06 1167 apt_0.7.12.dsc
 25c2852fce0e358309180f53d298a8c5ff1c1c6117237b0a87f6816c6aca0b35 1818439 apt_0.7.12.tar.gz
 bd633981b56716d4d5234f1414b2b21b459dd3b629377cbd604d046e70bbe3a0 95246 apt-doc_0.7.12_all.deb
 86256d280644ca4b173a78041e9b3382701814739b015242ac4c77032a4af609 119730 libapt-pkg-doc_0.7.12_all.deb
 7b88c12914ffb7d4bd1704283f26c50151cb7f034a762d1b3a1ab065fad9e5e5 1615134 apt_0.7.12_i386.deb
 f9f804372ee958d574c0a5f212b2d2c5b2a0a525071be1084966c06b595f9660 104200 libapt-pkg-dev_0.7.12_i386.deb
 e787a2da666684dbcf52c53cf7744745d02e0cfe042d7e0b6eeb4e120b670bfe 192318 apt-utils_0.7.12_i386.deb
 e7269a000c828433e552b7d367405e0c6f3c34d84ff3567741a3206302809dac 54250 apt-transport-https_0.7.12_i386.deb
Files: 
 8d6b5ef9d6c96ea35bfa0e6a768a1302 1167 admin important apt_0.7.12.dsc
 9f4326601e1011be48b2e46656c08fc9 1818439 admin important apt_0.7.12.tar.gz
 f070426057c1d8a8bf2cf5306313d114 95246 doc optional apt-doc_0.7.12_all.deb
 7bbb002bb377696c998be2918ba893f6 119730 doc optional libapt-pkg-doc_0.7.12_all.deb
 f156919b50ade1d8c7f213932239c85c 1615134 admin important apt_0.7.12_i386.deb
 703f8aec4eb4a40b1efd3fa4e7ab3e97 104200 libdevel optional libapt-pkg-dev_0.7.12_i386.deb
 7df624f3ae08cbc3cad06b10d8ba61c7 192318 admin important apt-utils_0.7.12_i386.deb
 3d528e0ea0d5dfcc4f892e85c722a053 54250 admin optional apt-transport-https_0.7.12_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFIFNtRch6xsM7kSXgRAg2XAJ96SeLhdywLI91id9bMTx/9x1j1oACgoVFg
uJv/bHWxbd7gYqoMUrP3dmo=
=XZXP
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 11 Jun 2008 07:32:25 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:15:06 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.